// Code generated by github.com/99designs/gqlgen, DO NOT EDIT.

package model

import (
	"fmt"
	"io"
	"strconv"
	"time"

	"gitlab.com/gett-hackathon/x-reality/gql-api/internal/uuid"
)

// The input used for updating and creating a address (Null or missing values won't be updated)
type AddressInput struct {
	Country *string `json:"country"`
	City    *string `json:"city"`
	Street  *string `json:"street"`
}

type CreateAppInput struct {
	Public       *bool            `json:"Public"`
	Name         *string          `json:"Name"`
	Description  *string          `json:"Description"`
	Contributors []uuid.ID        `json:"Contributors"`
	Category     *Category        `json:"Category"`
	DownloadUrls DownloadURLInput `json:"DownloadUrls"`
	LogoURL      *string          `json:"LogoURL"`
	PreviewUrls  []string         `json:"PreviewUrls"`
	Tags         []string         `json:"Tags"`
}

type DownloadURL struct {
	Vive      *string `json:"vive"`
	Oculus    *string `json:"oculus"`
	Microsoft *string `json:"microsoft"`
	Google    *string `json:"google"`
}

type DownloadURLInput struct {
	Vive      *string `json:"vive"`
	Oculus    *string `json:"oculus"`
	Microsoft *string `json:"microsoft"`
	Google    *string `json:"google"`
}

type DownloadUrls struct {
	Vive      *string `json:"vive"`
	Oculus    *string `json:"oculus"`
	Microsoft *string `json:"microsoft"`
	Google    *string `json:"google"`
}

// The input used for updating a account (Null or missing values won't be updated)
type UpdateAccountInput struct {
	Nickname   *string       `json:"nickname"`
	GivenName  *string       `json:"givenName"`
	FamilyName *string       `json:"familyName"`
	Bio        *string       `json:"bio"`
	PictureURL *string       `json:"pictureUrl"`
	Birthday   *time.Time    `json:"birthday"`
	Address    *AddressInput `json:"address"`
	KnowsAbout []string      `json:"knowsAbout"`
}

type UpdateAppInput struct {
	ID           uuid.ID          `json:"id"`
	Public       *bool            `json:"public"`
	Name         *string          `json:"name"`
	Description  *string          `json:"description"`
	Contributors []uuid.ID        `json:"contributors"`
	Category     *Category        `json:"category"`
	DownloadUrls DownloadURLInput `json:"downloadUrls"`
	LogoURL      *string          `json:"logoUrl"`
	PreviewUrls  []string         `json:"previewUrls"`
	Tags         []string         `json:"tags"`
}

type Category string

const (
	CategoryGames        Category = "Games"
	CategoryMarketing    Category = "Marketing"
	CategoryConstruction Category = "Construction"
	CategorySocial       Category = "Social"
	CategoryProductivity Category = "Productivity"
	CategoryLaboratory   Category = "Laboratory"
)

func (e Category) IsValid() bool {
	switch e {
	case CategoryGames, CategoryMarketing, CategoryConstruction, CategorySocial, CategoryProductivity, CategoryLaboratory:
		return true
	}
	return false
}

func (e Category) String() string {
	return string(e)
}

func (e *Category) UnmarshalGQL(v interface{}) error {
	str, ok := v.(string)
	if !ok {
		return fmt.Errorf("enums must be strings")
	}

	*e = Category(str)
	if !e.IsValid() {
		return fmt.Errorf("%s is not a valid Category", str)
	}
	return nil
}

func (e Category) MarshalGQL(w io.Writer) {
	fmt.Fprint(w, strconv.Quote(e.String()))
}

type ProfileVisibility string

const (
	// Private profiles expose only the nickname and pictureURL to other users if the nickname isn't set the firstName will be visible. Note that public Collections still are visible to other users
	ProfileVisibilityPrivate ProfileVisibility = "Private"
	// Discrete profiles expose the accounts pictureURL, nickname, full Name, country, bio, nickname
	ProfileVisibilityDiscrete ProfileVisibility = "Discrete"
	// Public profiles expose the accounts pictureURL, nickname, full Name, country, city, bio, nickname, birthday
	ProfileVisibilityPublic ProfileVisibility = "Public"
)

func (e ProfileVisibility) IsValid() bool {
	switch e {
	case ProfileVisibilityPrivate, ProfileVisibilityDiscrete, ProfileVisibilityPublic:
		return true
	}
	return false
}

func (e ProfileVisibility) String() string {
	return string(e)
}

func (e *ProfileVisibility) UnmarshalGQL(v interface{}) error {
	str, ok := v.(string)
	if !ok {
		return fmt.Errorf("enums must be strings")
	}

	*e = ProfileVisibility(str)
	if !e.IsValid() {
		return fmt.Errorf("%s is not a valid ProfileVisibility", str)
	}
	return nil
}

func (e ProfileVisibility) MarshalGQL(w io.Writer) {
	fmt.Fprint(w, strconv.Quote(e.String()))
}
